using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_BG_8K_88MA
{
    public class UserModuleClass_BG_8K_88MA : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        Crestron.Logos.SplusObjects.StringInput RX_MATRIX;
        Crestron.Logos.SplusObjects.DigitalInput POWER_ON;
        Crestron.Logos.SplusObjects.DigitalInput POWER_OFF;
        Crestron.Logos.SplusObjects.AnalogInput STORE_PRESET;
        Crestron.Logos.SplusObjects.AnalogInput RECALL_PRESET;
        Crestron.Logos.SplusObjects.AnalogInput CLEAR_PRESET;
        Crestron.Logos.SplusObjects.AnalogInput ALL_OUTPUT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> OUTPUT;
        Crestron.Logos.SplusObjects.StringOutput TX_MATRIX;
        object POWER_ON_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                
                __context__.SourceCodeLine = 163;
                TX_MATRIX  .UpdateValue ( "power 1!\r\n"  ) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object POWER_OFF_OnPush_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            
            __context__.SourceCodeLine = 168;
            TX_MATRIX  .UpdateValue ( "power 0!\r\n"  ) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object CLEAR_PRESET_OnChange_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 185;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)CLEAR_PRESET  .UshortValue) ; 
        __context__.SourceCodeLine = 186;
        TX_MATRIX  .UpdateValue ( "s clear preset " + STRINGOUT1 + "!\r\n"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object STORE_PRESET_OnChange_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 196;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)STORE_PRESET  .UshortValue) ; 
        __context__.SourceCodeLine = 197;
        TX_MATRIX  .UpdateValue ( "s save preset " + STRINGOUT1 + "!\r\n"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object RECALL_PRESET_OnChange_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 206;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)RECALL_PRESET  .UshortValue) ; 
        __context__.SourceCodeLine = 207;
        TX_MATRIX  .UpdateValue ( "s recall preset " + STRINGOUT1 + "!\r\n"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTPUT_OnChange_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort LASTNUM = 0;
        
        CrestronString SINPUT;
        CrestronString SOUTPUT;
        SINPUT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        SOUTPUT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 216;
        LASTNUM = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 217;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (LASTNUM == 1))  ) ) 
            {
            __context__.SourceCodeLine = 217;
            SOUTPUT  .UpdateValue ( "1"  ) ; 
            }
        
        else 
            {
            __context__.SourceCodeLine = 218;
            SOUTPUT  .UpdateValue ( Functions.ItoA (  (int) ( LASTNUM ) )  ) ; 
            }
        
        __context__.SourceCodeLine = 219;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( OUTPUT[ LASTNUM ] .UshortValue < 1 ))  ) ) 
            {
            __context__.SourceCodeLine = 219;
            SINPUT  .UpdateValue ( "0" + Functions.ItoA (  (int) ( OUTPUT[ LASTNUM ] .UshortValue ) )  ) ; 
            }
        
        else 
            {
            __context__.SourceCodeLine = 220;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT[ LASTNUM ] .UshortValue == 9))  ) ) 
                {
                __context__.SourceCodeLine = 220;
                SINPUT  .UpdateValue ( "0"  ) ; 
                }
            
            else 
                {
                __context__.SourceCodeLine = 221;
                SINPUT  .UpdateValue ( Functions.ItoA (  (int) ( OUTPUT[ LASTNUM ] .UshortValue ) )  ) ; 
                }
            
            }
        
        __context__.SourceCodeLine = 222;
        MakeString ( TX_MATRIX , "s output {0} in source {1}!\r\n", SOUTPUT , SINPUT ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object ALL_OUTPUT_OnChange_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 233;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)ALL_OUTPUT  .UshortValue) ; 
        __context__.SourceCodeLine = 234;
        TX_MATRIX  .UpdateValue ( "s output 0 in source " + STRINGOUT1 + "!\r\n"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}


public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    
    POWER_ON = new Crestron.Logos.SplusObjects.DigitalInput( POWER_ON__DigitalInput__, this );
    m_DigitalInputList.Add( POWER_ON__DigitalInput__, POWER_ON );
    
    POWER_OFF = new Crestron.Logos.SplusObjects.DigitalInput( POWER_OFF__DigitalInput__, this );
    m_DigitalInputList.Add( POWER_OFF__DigitalInput__, POWER_OFF );
    
    STORE_PRESET = new Crestron.Logos.SplusObjects.AnalogInput( STORE_PRESET__AnalogSerialInput__, this );
    m_AnalogInputList.Add( STORE_PRESET__AnalogSerialInput__, STORE_PRESET );
    
    RECALL_PRESET = new Crestron.Logos.SplusObjects.AnalogInput( RECALL_PRESET__AnalogSerialInput__, this );
    m_AnalogInputList.Add( RECALL_PRESET__AnalogSerialInput__, RECALL_PRESET );
    
    CLEAR_PRESET = new Crestron.Logos.SplusObjects.AnalogInput( CLEAR_PRESET__AnalogSerialInput__, this );
    m_AnalogInputList.Add( CLEAR_PRESET__AnalogSerialInput__, CLEAR_PRESET );
    
    ALL_OUTPUT = new Crestron.Logos.SplusObjects.AnalogInput( ALL_OUTPUT__AnalogSerialInput__, this );
    m_AnalogInputList.Add( ALL_OUTPUT__AnalogSerialInput__, ALL_OUTPUT );
    
    OUTPUT = new InOutArray<AnalogInput>( 8, this );
    for( uint i = 0; i < 8; i++ )
    {
        OUTPUT[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( OUTPUT__AnalogSerialInput__ + i, OUTPUT__AnalogSerialInput__, this );
        m_AnalogInputList.Add( OUTPUT__AnalogSerialInput__ + i, OUTPUT[i+1] );
    }
    
    RX_MATRIX = new Crestron.Logos.SplusObjects.StringInput( RX_MATRIX__AnalogSerialInput__, 255, this );
    m_StringInputList.Add( RX_MATRIX__AnalogSerialInput__, RX_MATRIX );
    
    TX_MATRIX = new Crestron.Logos.SplusObjects.StringOutput( TX_MATRIX__AnalogSerialOutput__, this );
    m_StringOutputList.Add( TX_MATRIX__AnalogSerialOutput__, TX_MATRIX );
    
    
    POWER_ON.OnDigitalPush.Add( new InputChangeHandlerWrapper( POWER_ON_OnPush_0, false ) );
    POWER_OFF.OnDigitalPush.Add( new InputChangeHandlerWrapper( POWER_OFF_OnPush_1, false ) );
    CLEAR_PRESET.OnAnalogChange.Add( new InputChangeHandlerWrapper( CLEAR_PRESET_OnChange_2, false ) );
    STORE_PRESET.OnAnalogChange.Add( new InputChangeHandlerWrapper( STORE_PRESET_OnChange_3, false ) );
    RECALL_PRESET.OnAnalogChange.Add( new InputChangeHandlerWrapper( RECALL_PRESET_OnChange_4, false ) );
    for( uint i = 0; i < 8; i++ )
        OUTPUT[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( OUTPUT_OnChange_5, false ) );
        
    ALL_OUTPUT.OnAnalogChange.Add( new InputChangeHandlerWrapper( ALL_OUTPUT_OnChange_6, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_BG_8K_88MA ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint RX_MATRIX__AnalogSerialInput__ = 0;
const uint POWER_ON__DigitalInput__ = 0;
const uint POWER_OFF__DigitalInput__ = 1;
const uint STORE_PRESET__AnalogSerialInput__ = 1;
const uint RECALL_PRESET__AnalogSerialInput__ = 2;
const uint CLEAR_PRESET__AnalogSerialInput__ = 3;
const uint ALL_OUTPUT__AnalogSerialInput__ = 4;
const uint OUTPUT__AnalogSerialInput__ = 5;
const uint TX_MATRIX__AnalogSerialOutput__ = 0;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
